<?php

namespace DataView;

class AufgabePropertyType_restrict {
  
  

  
  

    // --- Statische Methoden ---
  
  public static function renderTabTableAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
     ?><div class='fop-dv-buttonbar'><?php if((!\FOP\User::getIsGuest())) { ?><a class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored" onclick="var self = this; $.get(reloadaufgabePropertyType_restrict({action: 'open', fop_table: 'aufgabePropertyType', fop_id: '_', fop_from: location.href}, true)).then(function () { open_url(self.href, false);}); return false;" href="<?php echo htmlentities(\TablesRouter\AufgabePropertyType::createURL2(['from' => \FOP\Util::getBackUrl(), 'column_restrict' => $id])); ?>"><i class="material-icons">add</i> <?php echo(sprintf(_('create %s'), sprintf(_('%s-Eigenschaft'), _('Aufgabe')))); ?></a><?php } ?></div><?php 
								\FOP\User::getIsGuest();
								$itemheight = 32;
								$itemsperpage = ceil(1080 / $itemheight * 0.8);
								$page = (isset($_GET['page_aufgabePropertyType_restrict']) ? intval($_GET['page_aufgabePropertyType_restrict']) : 0);
								$addlines = (isset($_GET['addlines_aufgabePropertyType_restrict']) ? intval($_GET['addlines_aufgabePropertyType_restrict']) : 0);
								$firstitem = $page * $itemsperpage;
								$sqladdon = ' LIMIT ' . ($itemsperpage * 2) . ' OFFSET ' . ($firstitem);
								$data = self::getData($sqladdon, $_GET, $id);
								$arr = $data["items"];
								$itemcount = $data["itemcount"];
								$lastPage = ceil($itemcount/$itemsperpage-1);
								// calculate width of first column: 67px + 32px for each shortcut
								$firstColumnWidth = 66 + 34 + 34;
								$additionalLines = 0;

									// Spaltenliste zuerst aufbauen, damit sie noch umsortiert werden kann
									$order = 1000;
									$columns = [];
									
										if(true){
											$col = [
												'id' => 'name',
												'desc' => _('%s-Eigenschaft|Aufgabe'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['name'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'type',
												'desc' => _('Datentyp'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['type'] = $col;
										}
									

									// gespeicherte Spaltenanordnung
									foreach (\FOP\Database::query('SELECT * FROM fop_dataview WHERE '.qi('user').' = ' . \FOP\Database::quote(\FOP\User::getID()) . ' AND dataview = ' . \FOP\Database::quote('aufgabePropertyType_restrict'))->fetchAll(\PDO::FETCH_ASSOC) AS $column => $c) {
										if (isset($columns[$c['column']])) {
											$columns[$c['column']]['order'] = $c['order']; // order, width, collapsed
											$columns[$c['column']]['width'] = $c['width']; // order, width, collapsed
											$columns[$c['column']]['collapsed'] = $c['collapsed']; // order, width, collapsed
										}
									}

									// DOM vor-rendern
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='name'
												data-order='<?php echo intval($columns['name']['order']); ?>'
												data-width='<?php echo intval($columns['name']['width']); ?>'
												data-collapsed='<?php echo intval($columns['name']['collapsed']); ?>'
												style='width: <?php echo intval($columns['name']['width']); ?>px; <?php if ($columns['name']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadaufgabePropertyType_restrict(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_aufgabePropertyType_restrict_name'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_aufgabePropertyType_restrict_name'] = text.val(); } else { delete query['search_aufgabePropertyType_restrict_name']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_aufgabePropertyType_restrict').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_aufgabePropertyType_restrict_name'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_aufgabePropertyType_restrict_name'] = text2.val(); } else { delete query['searchnot_aufgabePropertyType_restrict_name']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_aufgabePropertyType_restrict').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_aufgabePropertyType_restrict'] == 'name ASC') {
			query['sort_aufgabePropertyType_restrict'] = 'name DESC';
		 } else if (query['sort_aufgabePropertyType_restrict'] == 'name DESC') {
		 	delete query['sort_aufgabePropertyType_restrict'];
		 } else {
			query['sort_aufgabePropertyType_restrict'] = 'name ASC';
		 }
		 reloadaufgabePropertyType_restrict();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(sprintf(_('%s-Eigenschaft'), _('Aufgabe'))); ?>'><?php echo(sprintf(_('%s-Eigenschaft'), _('Aufgabe'))); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_aufgabePropertyType_restrict']) && $_GET['sort_aufgabePropertyType_restrict'] == 'name ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_aufgabePropertyType_restrict']) && $_GET['sort_aufgabePropertyType_restrict'] == 'name DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_aufgabePropertyType_restrict_name']) || isset($_GET['range_max_aufgabePropertyType_restrict_name']) || isset($_GET['deps_aufgabePropertyType_restrict_name']) || isset($_GET['fullsearch_aufgabePropertyType_restrict_name']) || isset($_GET['dynamic_aufgabePropertyType_restrict_name']) || isset($_GET['search_aufgabePropertyType_restrict_name']) || isset($_GET['searchnot_aufgabePropertyType_restrict_name']) || isset($_GET['filter_aufgabePropertyType_restrict_name'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['name']['header'] = ob_get_contents(); ob_end_clean();
											$columns['name']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['name']['width']); ?>px; <?php if ($columns['name']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='name'><span class='overflow-text' title="<?php echo htmlentities($item['name']); ?>"><?php echo htmlentities($item['name']); ?></span></div><?php
											};
											$columns['name']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='name'
													data-order='<?php echo intval($columns['name']['order']); ?>'
													data-width='<?php echo intval($columns['name']['width']); ?>'
													data-collapsed='<?php echo intval($columns['name']['collapsed']); ?>'
													style='width: <?php echo intval($columns['name']['width']); ?>px; <?php if ($columns['name']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='type'
												data-order='<?php echo intval($columns['type']['order']); ?>'
												data-width='<?php echo intval($columns['type']['width']); ?>'
												data-collapsed='<?php echo intval($columns['type']['collapsed']); ?>'
												style='width: <?php echo intval($columns['type']['width']); ?>px; <?php if ($columns['type']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadaufgabePropertyType_restrict(); 
		}});
		win.append($('<input type=\'checkbox\'' + (querySet('filter_aufgabePropertyType_restrict_type', 'text') ? ' checked>': '>')).change(function (){querySet('filter_aufgabePropertyType_restrict_type', 'text', $(this).prop('checked')); changed=true;})).append('<span> </span><?php echo(_('Text')); ?><br/>').append($('<input type=\'checkbox\'' + (querySet('filter_aufgabePropertyType_restrict_type', 'date') ? ' checked>': '>')).change(function (){querySet('filter_aufgabePropertyType_restrict_type', 'date', $(this).prop('checked')); changed=true;})).append('<span> </span><?php echo(_('Datum')); ?><br/>').append($('<input type=\'checkbox\'' + (querySet('filter_aufgabePropertyType_restrict_type', 'double') ? ' checked>': '>')).change(function (){querySet('filter_aufgabePropertyType_restrict_type', 'double', $(this).prop('checked')); changed=true;})).append('<span> </span><?php echo(_('Zahl')); ?><br/>').append($('<input type=\'checkbox\'' + (querySet('filter_aufgabePropertyType_restrict_type', 'html') ? ' checked>': '>')).change(function (){querySet('filter_aufgabePropertyType_restrict_type', 'html', $(this).prop('checked')); changed=true;})).append('<span> </span><?php echo(_('Großer Text')); ?><br/>').append($('<input type=\'checkbox\'' + (querySet('filter_aufgabePropertyType_restrict_type', 'aufgabePropertyDropdown2') ? ' checked>': '>')).change(function (){querySet('filter_aufgabePropertyType_restrict_type', 'aufgabePropertyDropdown2', $(this).prop('checked')); changed=true;})).append('<span> </span><?php echo(_('Auswahl')); ?><br/>');
		return false;
	">
													<span class='title-title' title='<?php echo(_('Datentyp')); ?>'><?php echo(_('Datentyp')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_aufgabePropertyType_restrict']) && $_GET['sort_aufgabePropertyType_restrict'] == 'type ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_aufgabePropertyType_restrict']) && $_GET['sort_aufgabePropertyType_restrict'] == 'type DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_aufgabePropertyType_restrict_type']) || isset($_GET['range_max_aufgabePropertyType_restrict_type']) || isset($_GET['deps_aufgabePropertyType_restrict_type']) || isset($_GET['fullsearch_aufgabePropertyType_restrict_type']) || isset($_GET['dynamic_aufgabePropertyType_restrict_type']) || isset($_GET['search_aufgabePropertyType_restrict_type']) || isset($_GET['searchnot_aufgabePropertyType_restrict_type']) || isset($_GET['filter_aufgabePropertyType_restrict_type'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['type']['header'] = ob_get_contents(); ob_end_clean();
											$columns['type']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['type']['width']); ?>px; <?php if ($columns['type']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='type'><div><?php echo htmlentities(\Types\AufgabePropertyTypeType::toStringShort($item['type'])); ?>
		<br></div></div><?php
											};
											$columns['type']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='type'
													data-order='<?php echo intval($columns['type']['order']); ?>'
													data-width='<?php echo intval($columns['type']['width']); ?>'
													data-collapsed='<?php echo intval($columns['type']['collapsed']); ?>'
													style='width: <?php echo intval($columns['type']['width']); ?>px; <?php if ($columns['type']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									

									// sort by order
									uasort($columns, function ($a, $b) {
										return $a['order'] - $b['order'];
									});
									?>
									<style type='text/css'>
										#aufgabePropertyType_restrict-table .fop-table-header {
											height: <?php echo 32; ?>px;
										}
										#aufgabePropertyType_restrict-table .fop-table-header .fop-table-column .title,
										#aufgabePropertyType_restrict-table .fop-column-handle,
										#aufgabePropertyType_restrict-table .fop-table-row,
										#aufgabePropertyType_restrict-table .fop-table-row .fop-table-column,
										#aufgabePropertyType_restrict-table .fop-table-column-multicontrol,
										#aufgabePropertyType_restrict-table .fop-filter-button {
											height: 32px;
											line-height: 32px;
										}
										</style>
											<div class="fop-table" data-table-id="aufgabePropertyType_restrict">
											<div class="fop-legend"></div>
											<div class="fop-filter-string-wrapper"><div class="fop-filter-string"><label>Filter:</label> <span><?php echo self::getFilterHTML($_GET); ?></span></div></div>
											
											<?php if (isset($_GET['select'])) { echo '<br>'; } ?>
											<div class="fop-table-header">
											<?php if (!isset($_GET['select'])) { ?>
												<div class="fop-table-column noprint" style="width: <?php echo json_encode($firstColumnWidth); ?>px;">
													
													<div class="fop-table-column-multicontrol">
													<label class="mdl-checkbox mdl-js-checkbox"  style='width: auto;' for="aufgabePropertyType_restrict__all-checkbox">
														<input class="mdl-checkbox__input" id="aufgabePropertyType_restrict__all-checkbox" type="checkbox" onchange="checkaufgabePropertyType_restrict('all', 'ID', this.checked);">
														</label>
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon aufgabePropertyType_restrict__mass-action" style='visibility: hidden;' onclick="$.get('DataView/AufgabePropertyType_restrict/permissions?id=' + checkaufgabePropertyType_restrict(null, 'ID'), function (data) { for (var method in data) if (method != '__cnt') { var btn = $('[data-interaction-name=&quot;' + method + '&quot;]'); if (data[method] >= 1) btn.show(); else btn.hide(); btn.find('.cnt').text(data[method]); }; }); dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">more_vert</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterall" style="margin-right:auto; text-align:left;"
					onclick="for (key in query) if (key.indexOf('range_min_aufgabePropertyType_restrict_') == 0 || key.indexOf('range_max_aufgabePropertyType_restrict_') == 0 || key.indexOf('deps_aufgabePropertyType_restrict_') == 0 || key.indexOf('fullsearch_aufgabePropertyType_restrict_') == 0 || key.indexOf('dynamic_aufgabePropertyType_restrict_') == 0 || key.indexOf('search_aufgabePropertyType_restrict_') == 0 || key.indexOf('searchnot_aufgabePropertyType_restrict_') == 0 || key.indexOf('filter_aufgabePropertyType_restrict_') == 0) delete query[key]; reloadaufgabePropertyType_restrict(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">list</i></span><span class="fop-menu-caption" title="<?php echo(_('view all elements')); ?>"><?php echo(_('view all elements')); ?> 
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filteronly" style="margin-right:auto; text-align:left;"
					onclick="query['filter_aufgabePropertyType_restrict_ID'] = checkaufgabePropertyType_restrict(null, 'ID'); delete query['page_aufgabePropertyType_restrict']; reloadaufgabePropertyType_restrict(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">arrow_forward</i></span><span class="fop-menu-caption" title="<?php echo(_('view only these elements')); ?>"><?php echo(_('view only these elements')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterrange" style="margin-right:auto; text-align:left;"
					onclick="
		var ticks = new IDList(checkaufgabePropertyType_restrict(null, 'ID'));
		var range = prompt('Bitte geben Sie den Bereich ein', '1-' + ticks.count());
		var newticks = new IDList();
		if (range) {
			range = range.split('-');
			if (range.length == 1) {
				range.push(range[0]);
			}
			var skip = (range[0] || 1) - 1;
			var take = (range[1] || Infinity) - skip;
			for (var item of ticks.all()) {
				if (skip > 0) {
					skip--;
				} else if (take > 0) {
					newticks.push(item);
					take--;
				} else break;
			}
			checkaufgabePropertyType_restrict(newticks, 'ID', 'set');
		} $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">colorize</i></span><span class="fop-menu-caption" title="<?php echo(_('limit range')); ?>"><?php echo(_('limit range')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true && (!\FOP\User::getIsGuest())) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;"
					onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return;$.get('Tables/AufgabePropertyType/delete?ajax&from=<?php echo urlencode(\FOP\Util::getBackUrl()); ?>&id=' + escape(checkaufgabePropertyType_restrict(null, 'ID'))).then(function () { reloadaufgabePropertyType_restrict(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?>
														</ul>
														<!-- column hide -->
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon" onclick="dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">visibility</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php foreach ($columns AS $col) { ?>
																<li class="mdl-list__item mdl-button" onclick="
																	var isVisible = this.firstElementChild.innerText !== 'clear';
																	this.firstElementChild.innerText = isVisible ? 'clear' : 'visibility'; // switch icon
																	tableColumnVisibility('aufgabePropertyType_restrict', <?php echo htmlentities(json_encode($col['id'])); ?>, !isVisible); // the rest is up to a helper function in layout/tables.fop
																	">
																	<i class="material-icons"><?php if ($col['collapsed']) { echo 'clear'; } else { echo 'visibility'; }?></i>
																	<?php echo htmlentities($col['desc']); ?>
																</li>
															<?php } ?>
															<li class="mdl-list__item mdl-button" onclick="
																$.get('FOP/Index/dataview?data='+encodeURIComponent(JSON.stringify({dataview: 'aufgabePropertyType_restrict', reset: true}))).then(function () { location.reload(); });
																">
																<i class="material-icons">refresh</i>
																<?php echo _('reset all'); ?>
															</li>
														</ul>
													</div>
												</div><?php }
												
												foreach ($columns AS $col) {
													// Spalten-Überschrift rendern
													echo $col['header'];
												} ?>
											 </div>
											
											<div class="fop-table-body" id="table_aufgabePropertyType_restrict" <?php \EasyEditor\Navigation::printScroll('dv.AufgabePropertyType_restrict', '/* scroll horiz */ this.previousElementSibling.firstElementChild.style.marginLeft = \'-\' + this.scrollLeft + \'px\';
												/* scroll verti */
												var self = this;
												if (window.DataViewScrollReloadTimeout) clearTimeout(window.DataViewScrollReloadTimeout);
												window.DataViewScrollReloadTimeout = setTimeout(function () {
													var currentPage = parseInt(query[\'page_aufgabePropertyType_restrict\'] || 0);
													var paddingTop = parseInt( self.lastElementChild.style.paddingTop, 10);
													var wantedPage = Math.max(0, currentPage + Math.floor((self.scrollTop - paddingTop) / ' . ($itemheight * $itemsperpage) . '));
													if (wantedPage != currentPage) {
														query[\'page_aufgabePropertyType_restrict\'] = wantedPage;
														reloadaufgabePropertyType_restrict(undefined, undefined, true);
													}
												}, 50);
											'); ?>>
												<div class="fop-table-body-inner" style="min-height: <?php echo 12 + $itemheight * ($itemcount + $additionalLines); ?>px; padding-top: <?php echo $itemheight * $itemsperpage * $page; ?>px;">
												<?php foreach($arr as $itempos => $item) {
													?>
													<div class="fop-table-row" style="" data-aufgabePropertyType-id="<?php echo htmlentities($item['ID']); ?>"<?php if (isset($item['ID'])){
														if (isset($_GET['select']) && isset($_GET['from'])) {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) window.location.href=' . htmlentities(json_encode($_GET['from'] . '&colvalue=' . urlencode($item['ID']))) . ';" ';
														} else {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) open_url(reloadaufgabePropertyType_restrict({action: \'open\', fop_table: \'aufgabePropertyType\', fop_id: ' .  htmlentities(json_encode($item['ID'])) . ', fop_from: location.href}, true), false);"';
														}
													}?> >

													<?php if (!isset($_GET['select'])) { ?>
													<div class='fop-table-column noprint' style="width: <?php echo json_encode($firstColumnWidth); ?>px;" onclick="$(this).find('input[type=checkbox]').first().click(); event.stopPropagation();">
													<label onclick="event.stopPropagation();" class="mdl-checkbox mdl-js-checkbox aufgabePropertyType_restrict__checkbox aufgabePropertyType_restrict__checkbox aufgabePropertyType_restrict__checkbox-ID-<?php echo htmlentities($item['ID']); ?>" style="width: auto;" for="aufgabePropertyType_restrict__<?php echo htmlentities($itempos); ?>-checkbox">
													<input class="mdl-checkbox__input" id="aufgabePropertyType_restrict__<?php echo htmlentities($itempos); ?>-checkbox" type="checkbox" onchange="<?php if (isset($item['ID'])) echo 'checkaufgabePropertyType_restrict(' . htmlentities(json_encode($item['ID'])) . ', \'ID\', this.checked); ' ?>">
													</label><button type="button" class="mdl-button mdl-js-button mdl-button--icon aufgabePropertyType_restrict__action" onclick="
														event.stopPropagation();
														dropDownFixPosition($(this), $(this).next());
														">
														<i class="material-icons">more_vert</i>
													</button><ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu" id="fop-scroll-menu-aufgabePropertyType_restrict-action-<?php echo $item['ID'] ?? 0; ?>">
														<?php
		if(isset($item['ID']) && $item['operation::view']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="view" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\AufgabePropertyType::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick=" if (!event.ctrlKey) { open_url(reloadaufgabePropertyType_restrict({action: 'open', fop_table: 'aufgabePropertyType', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; } $(this).closest('.overlay').click(); return false;  
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">find_in_page</i></span><span class="fop-menu-caption" title="<?php echo(_('open')); ?>"><?php echo(_('open')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="edit" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\AufgabePropertyType::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">edit</i></span><span class="fop-menu-caption" title="<?php echo(_('edit')); ?>"><?php echo(_('edit')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && (!\FOP\User::getIsGuest()) && $item['operation::dvia:aufgabePropertyDropdown:property']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="create_aufgabePropertyDropdown_property" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\AufgabePropertyDropdown::createURL2(['column_property' => $item['ID'], 'from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">create</i></span><span class="fop-menu-caption" title="<?php echo(sprintf(_('create %s'), sprintf(_('%s-Eigenschaften-Auswahl'), _('Aufgabe')))); ?>"><?php echo(sprintf(_('create %s'), sprintf(_('%s-Eigenschaften-Auswahl'), _('Aufgabe')))); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::delete']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;" href="#"
				onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return false;   $.get('Tables/AufgabePropertyType/delete?ajax&id=<?php echo htmlentities($item['ID']);?>&from=<?php echo htmlentities(\FOP\Util::getBackUrl());?>').then(function () { reloadaufgabePropertyType_restrict(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?></span>
			</a>
		<?php } ?>
													</ul><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="aufgabePropertyType" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="edit" href="<?php echo htmlentities(\TablesRouter\AufgabePropertyType::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadaufgabePropertyType_restrict();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('edit')); ?>">
				<i class="material-icons">edit</i>
			</a><?php } ?><?php
		if(isset($item['ID']) && $item['operation::view']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="aufgabePropertyType" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="view" href="<?php echo htmlentities(\TablesRouter\AufgabePropertyType::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();  if (!event.ctrlKey) { open_url(reloadaufgabePropertyType_restrict({action: 'open', fop_table: 'aufgabePropertyType', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; }  reloadaufgabePropertyType_restrict();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('open')); ?>">
				<i class="material-icons">find_in_page</i>
			</a><?php } ?>
													</div><?php } ?><?php
													
													foreach ($columns AS $col) {
														$col['render']($item);
													}
													?></div>
												 <?php }?>

													</div>
												</div>

												
												
												</div><?php
												
	
    
  }

  public static function renderScript($id) { 
    
    
    // --- BLOCK: main ---
    
								\FOP\I18n::ensureIsLoaded();
								?>
								<script type="text/javascript">
									
    function changefilter_aufgabePropertyType_restrict_restrictListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_aufgabePropertyType_restrict_restrict', val, cb.checked);
		  } else {
			  delete query['filter_aufgabePropertyType_restrict_restrict'];
		  }reloadaufgabePropertyType_restrict();
        
    }

		var if36092f5f5076f96a6655b6f3f852a90bfbd110350cf383907e8d7ab41fd3e49timeout = null;
		function changefilter_aufgabePropertyType_restrict_restrictSearchFilter(val, callback) {
			if(if36092f5f5076f96a6655b6f3f852a90bfbd110350cf383907e8d7ab41fd3e49timeout) clearTimeout(if36092f5f5076f96a6655b6f3f852a90bfbd110350cf383907e8d7ab41fd3e49timeout);

			if36092f5f5076f96a6655b6f3f852a90bfbd110350cf383907e8d7ab41fd3e49timeout = setTimeout(function() {
				$.getJSON(reloadaufgabePropertyType_restrict({action: 'getfilter_aufgabePropertyType_restrict_restrictItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_aufgabePropertyType_restrict_restrict_orig'] = val;
				});
			}, 300);
		}

	function getfilter_aufgabePropertyType_restrict_restrictListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_aufgabePropertyType_restrict_restrict_orig']) ? json_encode($_GET['filter_aufgabePropertyType_restrict_restrict_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="f36092f5f5076f96a6655b6f3f852a90bfbd110350cf383907e8d7ab41fd3e49" type="text">' +
			'<label class="mdl-textfield__label" for="f36092f5f5076f96a6655b6f3f852a90bfbd110350cf383907e8d7ab41fd3e49">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_aufgabePropertyType_restrict_restrict', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_aufgabePropertyType_restrict_restrict_orig'] = '';
					delete query['filter_aufgabePropertyType_restrict_restrict'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadaufgabePropertyType_restrict();
					
				} else {
					$('#table_aufgabePropertyType_restrict').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_aufgabePropertyType_restrict_restrictSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\AufgabePropertyType_restrict::getfilter_aufgabePropertyType_restrict_restrictItemsByStringAction('', $id));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_aufgabePropertyType_restrict_restrict_orig'] = '';
				delete query['filter_aufgabePropertyType_restrict_restrict'];
				reload('', items);reloadaufgabePropertyType_restrict();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_aufgabePropertyType_restrict_restrict', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_aufgabePropertyType_restrict_restrictListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									
    function changefilter_aufgabePropertyType_restrict_restrictListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_aufgabePropertyType_restrict_restrict', val, cb.checked);
		  } else {
			  delete query['filter_aufgabePropertyType_restrict_restrict'];
		  }reloadaufgabePropertyType_restrict();
        
    }

		var if36092f5f5076f96a6655b6f3f852a90bfbd110350cf383907e8d7ab41fd3e49timeout = null;
		function changefilter_aufgabePropertyType_restrict_restrictSearchFilter(val, callback) {
			if(if36092f5f5076f96a6655b6f3f852a90bfbd110350cf383907e8d7ab41fd3e49timeout) clearTimeout(if36092f5f5076f96a6655b6f3f852a90bfbd110350cf383907e8d7ab41fd3e49timeout);

			if36092f5f5076f96a6655b6f3f852a90bfbd110350cf383907e8d7ab41fd3e49timeout = setTimeout(function() {
				$.getJSON(reloadaufgabePropertyType_restrict({action: 'getfilter_aufgabePropertyType_restrict_restrictItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_aufgabePropertyType_restrict_restrict_orig'] = val;
				});
			}, 300);
		}

	function getfilter_aufgabePropertyType_restrict_restrictListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_aufgabePropertyType_restrict_restrict_orig']) ? json_encode($_GET['filter_aufgabePropertyType_restrict_restrict_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="f36092f5f5076f96a6655b6f3f852a90bfbd110350cf383907e8d7ab41fd3e49" type="text">' +
			'<label class="mdl-textfield__label" for="f36092f5f5076f96a6655b6f3f852a90bfbd110350cf383907e8d7ab41fd3e49">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_aufgabePropertyType_restrict_restrict', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_aufgabePropertyType_restrict_restrict_orig'] = '';
					delete query['filter_aufgabePropertyType_restrict_restrict'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadaufgabePropertyType_restrict();
					
				} else {
					$('#table_aufgabePropertyType_restrict').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_aufgabePropertyType_restrict_restrictSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\AufgabePropertyType_restrict::getfilter_aufgabePropertyType_restrict_restrictItemsByStringAction('', $id));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_aufgabePropertyType_restrict_restrict_orig'] = '';
				delete query['filter_aufgabePropertyType_restrict_restrict'];
				reload('', items);reloadaufgabePropertyType_restrict();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_aufgabePropertyType_restrict_restrict', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_aufgabePropertyType_restrict_restrictListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									function updateNumberaufgabePropertyType_restrict(col) {
										//var checklist = window.DataViewChecked['aufgabePropertyType_restrict'][col];
										//if (checklist.id) {
											// checklist is online
											// TODO: check if cache is alive, otherwise reload from ajax, delay execution and return now
											//checklist.ranges = [[1,10000000]]; // mostly we use indirect idlists to tick all marks; so this is an approximation
										//}
										// checkboxes aktualisieren
										if (window.DataViewChecked && window.DataViewChecked['aufgabePropertyType_restrict'] && window.DataViewChecked['aufgabePropertyType_restrict'][col].ranges.length > 0) {
											$('.aufgabePropertyType_restrict__mass-action').css('visibility', 'visible');
											$('.aufgabePropertyType_restrict__action').css('visibility', 'hidden');
										} else {
											$('.aufgabePropertyType_restrict__mass-action').css('visibility', 'hidden');
											$('.aufgabePropertyType_restrict__action').css('visibility', 'visible');
										}
										$('.aufgabePropertyType_restrict__checkbox').each(function (idx, x) {
											for (var cssclass of x.classList) {
												if (cssclass.startsWith('aufgabePropertyType_restrict__checkbox-'+col+'-')) {
													var my_id = cssclass.substr(('aufgabePropertyType_restrict__checkbox-'+col+'-').length);
													if (window.DataViewChecked) {
														x.MaterialCheckbox[checklist.has(my_id) ? 'check' : 'uncheck']();
													}
												}
											}
										});
									}
									function reloadaufgabePropertyType_restrict (params, returnUrl, onlyScroll, addPadding = 0) {
										// copy query
										let nq = JSON.parse(JSON.stringify(query));
										nq['parent_request'] = <?php echo json_encode(strtok(\FOP\Util::getBackUrl(), '?')); ?>;
										<?php if (isset($_GET['select'])) { ?>nq['select'] = 'select';<?php } ?>
										nq["id"] = <?php echo json_encode($id); ?>; 
										if (params) {
											for (var i in params) nq[i] = params[i];
											var action = nq['action'];
											delete nq['action'];
											let querystr = "DataView/AufgabePropertyType_restrict/" + action + "?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// direkt aufrufen (ist wohl ein Download oder so)
											if (returnUrl) return querystr;
											window.location.href = querystr;
										} else {
											let querystr;
											
											
											<?php if ((!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest())) { ?>
											delete nq['action'];
											querystr = "DataView/AufgabePropertyType_restrict/renderTabTable?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// per Ajax laden
											if(!$("#aufgabePropertyType_restrict-table")?.parent()?.parent()?.hasClass('fop-form-feature-collapsed') || $("#aufgabePropertyType_restrict-table")?.parent()?.parent()?.hasClass('fop-form-feature-mode-area')) {
											$.get(querystr, function(data){
												var tab = $("#aufgabePropertyType_restrict-table");
												var top = tab.find('.fop-table-body-inner');
												var el;
												if (onlyScroll && (el = $('<div class="tabcontent">' + data + '</div>').find('.fop-table-body-inner'))) {
													// nur Scroll-Bereich ersetzen
													var paddingTop = parseInt(el.css('paddingTop') || '0px', 10);
													var minHeight = parseInt(el.css('minHeight'), 10)
													paddingTop += addPadding;
													minHeight += addPadding;
													top.css({paddingTop: paddingTop.toString()+'px', minHeight: minHeight.toString()+'px'}); // Offset
													el = el.children();
													top.empty();
													top.append(el);
													el = top; // top-upgrade doppelt machen, dadurch vermeiden wir das Array-upgrade => Performance
												} else {
													// gesamten Tab ersetzen
													tab.children().remove();
													el = tab.html('<div class="tabcontent">' + data + '</div>');
												}
												try {
													for (var i = 0; i < el.length; i++) upgradeDOM(el[i]);
												} catch (e) {
													console.log(e);
												}
												upgradeTable(el.find('.fop-table .fop-table-header')); // Falls es Tabellen-Layout ist: Spalten-Order anpassen
												flushURL(); // Neue URL in Titelleiste eintragen

												// Checkbox-Auswahl ankreuzen
												updateNumberaufgabePropertyType_restrict('ID');
											});
											} else {
												// gesamten Tab ersetzen
												var tab = $("#aufgabePropertyType_restrict-table");
												tab.children().remove();
												el = tab.html('<div class="fop-lazy-reload" onclick="reloadaufgabePropertyType_restrict()"></div>');
											}
											<?php } ?>
											
										}
									}
									function checkaufgabePropertyType_restrict (id, col, checked) {
										// ID-Liste aufbauen
										if (!window.DataViewChecked) window.DataViewChecked = {};
										if (!window.DataViewChecked['aufgabePropertyType_restrict']) window.DataViewChecked['aufgabePropertyType_restrict'] = {};
										if (!window.DataViewChecked['aufgabePropertyType_restrict'][col]) window.DataViewChecked['aufgabePropertyType_restrict'][col] = new IDList();

										// Abfrage aller gecheckten IDs für eine Tabelle
										if (!id) {
											return window.DataViewChecked['aufgabePropertyType_restrict'][col].toString();
										}

										// check all, check id
										if (id == 'all') {
											// TODO: umbauen #1289: 'all' auch nur auf ne idlist reduzieren
											if (checked) {
												$.get(reloadaufgabePropertyType_restrict({action: 'getids', col: col}, true), function (ids) {
													window.DataViewChecked['aufgabePropertyType_restrict'][col] = new IDList(ids);
													updateNumberaufgabePropertyType_restrict(col);
												});
											} else {
												window.DataViewChecked['aufgabePropertyType_restrict'][col] = new IDList();
												updateNumberaufgabePropertyType_restrict(col);
											}
										} else {
											var ids = new IDList(id);
											var allcb = $('#aufgabePropertyType_restrict__all-checkbox');
											if (allcb[0]) {
												allcb[0].parentElement.MaterialCheckbox.uncheck(); // TODO: prüfen, ob Gruppen-CBs voll werden
											}
											if (checked == 'set') {
												window.DataViewChecked['aufgabePropertyType_restrict'][col] = ids;
											} else for (id of ids.all()) {
												if (checked) {
													window.DataViewChecked['aufgabePropertyType_restrict'][col].push(id);
												} else {
													window.DataViewChecked['aufgabePropertyType_restrict'][col].remove(id);
												}
											}
											updateNumberaufgabePropertyType_restrict(col);
										}
									}
								</script><?php

    
  }

  public static function renderSpecialFilters() { 
    
    
    // --- BLOCK: main ---
    ?>
	
	<script type"text/javascript">
		function updateSpecialFilter(param, val) {
			query[param] = val.toString();reloadaufgabePropertyType_restrict();
			
		}

	</script>
	<?php
	
    
  }

  public static function getSQL($params, $id) { 
    
    
    // --- BLOCK: main ---
    
								// returns a sql snippet 'FROM (...) AS t WHERE' where you can prepend your select clauses and append your ORDER LIMIT
								$sql = 'FROM (SELECT /* ID */ '.qi('ID').' AS '.qi('ID').',
									/* name */ '.qi('name').' AS '.qi('name').',
									/* operation::48q5y2W6 */ (('.qi('aufgabePropertyType').'.'.qi('type').') = (\'aufgabePropertyDropdown2\')) AS '.qi('operation::48q5y2W6').',
									/* operation::create */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::create').',
									/* operation::delete */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::delete').',
									/* operation::dvia:aufgabePropertyDropdown:property */ (('.qi('aufgabePropertyType').'.'.qi('type').') = (\'aufgabePropertyDropdown2\')) AS '.qi('operation::dvia:aufgabePropertyDropdown:property').',
									/* operation::edit */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::edit').',
									/* operation::index */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::index').',
									/* operation::view */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::view').',
									/* restrict */ '.qi('restrict').' AS '.qi('restrict').',
									/* restrict::canView */ '.qi('ref:restrict').'.'.qi('restrict:canView').' AS '.qi('restrict::canView').',
									/* restrict::description */ '.qi('ref:restrict').'.'.qi('restrict:description').' AS '.qi('restrict::description').',
									/* sortableOrder */ '.qi('sortableOrder').' AS '.qi('sortableOrder').',
									/* type */ '.qi('type').' AS '.qi('type').',
									1
								FROM '.qi('aufgabePropertyType').' '.qi('aufgabePropertyType').'
								LEFT JOIN (SELECT '.qi('ID').' AS '.qi('restrict:ID').', '.qi('aufgabeType').'.'.qi('name').' AS '.qi('restrict:description').', ('.(\FOP\User::getIsGuest() ? 'false' : 'true').') AS '.qi('restrict:canView').' FROM '.qi('aufgabeType').') '.qi('ref:restrict').' ON '.qi('ref:restrict').'.'.qi('restrict:ID').' = '.qi('restrict').'
								WHERE ('.qi('restrict').' = ' . \FOP\Database::quote($id) . ')
									AND ('.(\FOP\User::getIsGuest() ? 'false' : 'true').')) AS t
								LEFT JOIN '.qi('aufgabeType').' AS '.qi('sorter-restrict').' ON t.'.qi('restrict').' = '.qi('sorter-restrict').'.'.qi('ID').'
								WHERE ' . (isset($params['filter_aufgabePropertyType_restrict_type']) ? ($params['filter_aufgabePropertyType_restrict_type'] !== '' ? ('(' . (new \FOP\IDList($params['filter_aufgabePropertyType_restrict_type']))->toSQL('t.'.qi('type').'') . ') AND ') : '') : '') . 
								(isset($params['filter_aufgabePropertyType_restrict_restrict']) ? ($params['filter_aufgabePropertyType_restrict_restrict'] !== '' ? ('(' . (new \FOP\IDList($params['filter_aufgabePropertyType_restrict_restrict']))->toSQL('t.'.qi('restrict').'') . ') AND ') : '') : '') . 
								(isset($params['filter_aufgabePropertyType_restrict_name']) ? ($params['filter_aufgabePropertyType_restrict_name'] !== '' ? ('(' . (new \FOP\IDList($params['filter_aufgabePropertyType_restrict_name']))->toSQL('t.'.qi('name').'') . ') AND ') : '') : '') . 
								(isset($params['filter_aufgabePropertyType_restrict_ID']) ? ($params['filter_aufgabePropertyType_restrict_ID'] !== '' ? ('(' . (new \FOP\IDList($params['filter_aufgabePropertyType_restrict_ID']))->toSQL('t.'.qi('ID').'') . ') AND ') : '') : '') . 
								(isset($params['search_aufgabePropertyType_restrict_name']) ? 't.'.qi('name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_aufgabePropertyType_restrict_name'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_aufgabePropertyType_restrict_name']) ? 'NOT t.'.qi('name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_aufgabePropertyType_restrict_name'] . '%') . ' AND ' : '') . 
								(isset($params['search_aufgabePropertyType_restrict']) ? '(' . 't.'.qi('name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_aufgabePropertyType_restrict'] . '%') . ') AND ' : '') . 
								'
								 TRUE ';
								return $sql;
	
    
  }

  public static function getidsAction($col, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
			$q = \FOP\Database::query('SELECT t.'.qi($col).' '.self::getSQL($_GET, $id));
			$result = new \FOP\IDList();
			while ($item = $q->fetchColumn()) {
				$result->push($item);
			}
			die($result->toString());

    
  }

  public static function permissionsAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		$ids = new \FOP\IDList($id);
		header('Content-Type: application/json');
		
		$perms = \FOP\Database::query('SELECT COUNT(*) AS __cnt, SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filteronly').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterrange').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterall').', SUM(CASE ('.(\FOP\User::getIsGuest() ? 'false' : 'true').') WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('delete').' FROM '.qi('aufgabePropertyType').' WHERE ' . $ids->toSQL(qi('ID')))->fetch(\PDO::FETCH_ASSOC);
		
		return $perms;
	
    
  }

  public static function getfilter_aufgabePropertyType_restrict_restrictItemsByStringAction($fstr, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		// Auf aktive DataView-Items einschränken
		$params = $_GET;
		unset($params['filter_aufgabePropertyType_restrict_restrict']);
		return \Types\AufgabeType::getItems(null, -1, $fstr, ''.qi('ID').' IN (SELECT DISTINCT t.'.qi('restrict').''.self::getSQL($params, $id).')');
	

    
  }

  public static function getData($sqladdon, $params, $id, $stream = false ) { 
    
    
    // --- BLOCK: main ---
    
								$sql = self::getSQL($params, $id);

								$order = (\FOP\Util::array_value(array(
									'restrict ASC' => 'ORDER BY '.qi('sorter-restrict').'.'.qi('sortableOrder').' , '.qi('sorter-restrict').'.'.qi('sortableOrder').' ',
									'restrict DESC' => 'ORDER BY '.qi('sorter-restrict').'.'.qi('sortableOrder').' DESC, '.qi('sorter-restrict').'.'.qi('sortableOrder').' DESC',
									'name ASC' => 'ORDER BY t.'.qi('name').' ASC',
									'name DESC' => 'ORDER BY t.'.qi('name').' DESC',
									'' => ''), isset($params['sort_aufgabePropertyType_restrict']) ? $params['sort_aufgabePropertyType_restrict'] : '') ?: 'ORDER BY '.qi('t').'.'.qi('sortableOrder').' ');
								// wenn sqladdon bereits ein ORDER enthält, kein order aufbauen
								if (strpos($sqladdon, 'ORDER') !== false) {
									$order = '';
								}
								if ($stream) {
									// als Stream (währenddessen darf keine weitere SQL-Query laufen) für große Datenmengen und Statistiken
									$result = (function () use ($sql, $order, $sqladdon) {
										$stream = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
										while ($item = $stream->fetch(\PDO::FETCH_ASSOC)) {
											$item['restrict'] = \FOP\Sanitizers::null_converter($item['restrict']);
											
											yield $item;
										}
									})();
								} else {
									// als RAM-Array
									$result = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
									$arr = $result->fetchAll(\PDO::FETCH_ASSOC);
									$itemcount = count($arr);

									foreach($arr as $i => &$item){
										$item['restrict'] = \FOP\Sanitizers::null_converter($item['restrict']);
										
									}
									unset($item);

									$result = ["items" => $arr, "itemcount" => $itemcount];

									
								}

								return $result;
	
    
  }

  public static function getFilterHTML($params, $delimiter = ', ' , $showButton = true ) { 
    
    
    // --- BLOCK: main ---
    
		// Contract: ist showButton == false, sollten keine HTML-Tags im Output enthalten sein (Verwendung in Dateinamen!!)
		$filters = [];
		if (isset($params['filter_aufgabePropertyType_restrict_type'])) {
		if ($params['filter_aufgabePropertyType_restrict_type'] == '_null') {
			array_push($filters, _('Datentyp') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_aufgabePropertyType_restrict_type']))->all() AS $val) {
				$value = \Types\AufgabePropertyTypeType::toString($val);
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Datentyp') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_aufgabePropertyType_restrict_name'])) {
		if ($params['filter_aufgabePropertyType_restrict_name'] == '_null') {
			array_push($filters, _('%s-Eigenschaft|Aufgabe') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_aufgabePropertyType_restrict_name']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('%s-Eigenschaft|Aufgabe') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_aufgabePropertyType_restrict_restrict'])) {
		if ($params['filter_aufgabePropertyType_restrict_restrict'] == '_null') {
			array_push($filters, _('Typ') . ': ' . _(''));
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_aufgabePropertyType_restrict_restrict']))->all() AS $val) {
				$value = 
  \FOP\Database::query('SELECT '.qi('aufgabeType').'.'.qi('name').' AS description FROM '.qi('aufgabeType').' WHERE '.qi('ID').' = ' . \FOP\Database::quote($val))->fetchColumn() ?: _('')
;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Typ') . ': ' . implode(', ', $values));
		}
	}if (isset($params['search_aufgabePropertyType_restrict_name'])) {
		array_push($filters, _('name') . ' ' . _('filter_contains') . ' ' . $params['search_aufgabePropertyType_restrict_name']);
	}if (isset($params['searchnot_aufgabePropertyType_restrict_name'])) {
		array_push($filters, _('name') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_aufgabePropertyType_restrict_name']);
	}
		if (count($filters)) {
			$result = implode($delimiter, array_map(function ($filter) {
				if (is_array($filter)) {
					return implode('', $filter);
				}
				return htmlentities($filter);
			}, $filters))
			// Button, um Filter zu entfernen
			. ($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="for (var q in query) {if (q.includes(\'_aufgabePropertyType_restrict_\')) delete query[q];} reloadaufgabePropertyType_restrict(); ">clear</i>' : '');
		} else {
			$result = _('no_filter');
		}
		return $result;
	
    
  }

  public static function openAction($fop_table, $fop_id, $fop_from, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    

if ($fop_table == 'aufgabePropertyType') {
	\FOP\Session::setPayload('dv-aufgabePropertyType', [
		'id' => 'aufgabePropertyType_restrict',
		'tbl' => 'aufgabePropertyType',
		'idcol' => 'ID',
		'prev' => \DataViewRouter\AufgabePropertyType_restrict::stepURL('aufgabePropertyType', 'XXX', -1),
		'next' => \DataViewRouter\AufgabePropertyType_restrict::stepURL('aufgabePropertyType', 'XXX',  1),
		'from' => $fop_from,
		'param_id' => $id
	]);
	
	if ($fop_id == '_') return; // nur Rückreferenz setzen, nicht öffnen
	$params = [];
	if (isset($_GET['popup'])) $params['popup'] = true;
	if (isset($_GET['from'])) $params['from'] = $_GET['from'];
	$params['id'] = $fop_id;
	
	$url = \TablesRouter\AufgabePropertyType::viewURL2($params);
	header('Location: ' . $url);
}

die();
    
  }

  public static function stepAction($tbl, $id, $step) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
	$dv = \FOP\Session::getPayload('dv-'.$tbl);
	$url = $dv['from'];
	$parts = parse_url($url);
	parse_str($parts['query'], $query);
	$data = self::getData('', $query, $dv['param_id']);
	$col = $dv['idcol'];
	$ids = array_map(function ($x) use ($col) {return $x[$col];}, $data['items']);
	if (!count($ids)) {
		header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])));
		die();
	}
	$idx = array_search($id, $ids);
	$idx += count($ids) + $step;
	$idx = $idx % count($ids);
	header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])) . '/view?id=' . urlencode($ids[$idx]));
	die();

    
  }


  
  

  
  
}



